/*
 * Description:
 *     History: yang@haipo.me, 2017/04/16, create
 */

#ifndef _MP_CONFIG_H_
#define _MP_CONFIG_H_

#include <assert.h>
#include <ctype.h>
#include <errno.h>
#include <inttypes.h>
#include <mach/error.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "nw_clt.h"
#include "nw_job.h"
#include "nw_svr.h"
#include "nw_timer.h"

#include "nw_log.h"
#include "ut_cli.h"
#include "ut_config.h"
#include "ut_decimal.h"
#include "ut_define.h"
#include "ut_kafka.h"
#include "ut_list.h"
#include "ut_misc.h"
#include "ut_rpc_clt.h"
#include "ut_rpc_cmd.h"
#include "ut_rpc_svr.h"
#include "ut_sds.h"
#include "ut_signal.h"

struct settings {
  bool debug;
  process_cfg process;
  log_cfg log;
  alert_cfg alert;
  rpc_svr_cfg svr;
  kafka_consumer_cfg deals;
  redis_sentinel_cfg redis;
  int timezone;
  int sec_max;
  int min_max;
  int hour_max;
  double cache_timeout;
  char *accesshttp;
};

extern struct settings settings;
int init_config(const char *path);

#endif
